#! /bin/sh
#
# makedata.sh
#
# Version:		@(#)makedata.sh  $Revision: 1.1.1.1 $  12-Feb-2005  s-fusa@i.kyushu-u.ac.jp
#

# ./makedata.sh -t XMLFILE ǡƥȥΡɤññ̤ǥ롥
# ./makedata.sh -f XMLFILE ǥեեޥåȤ롥ΤȤ
#               -m MAXNODE ǺΡɿ¤뤳ȤǤ롥
# ./makedata.sh -c XMLFILE  XMLFILE  UNOT ΥƥȥեޥåȤѴ롥


# ./makedata.sh -tfc -m 2000 XMLFILE ͤƱ˻ǤޤĤꤷʤȲ⤷ޤ
# ./makedata.sh -c XMLFILE1 XMLFILE2 ... Ϣ³ѴǤޤ
#
# ϥեϡϥե˥եåդ¸ޤ
# ץȤ褯ɤǻѤƤ

while getopts :tfm:c OPT; do
    case $OPT in
        t)
            TAGGER_ON=1
            ;;
        f)
            FORMATTER_ON=1
            ;;
        m)
            MAXNODE=$OPTARG
            ;;
        c)
            CONVERTER_ON=1
            ;;
        *)
            echo "Error: Unknown Option."
        exit 2
    esac
done
shift `expr $OPTIND - 1`


makedata () {
# init
    MEM="512m"
    set -o noclobber

# text tagger
    if [ "$TAGGER_ON" = 1 ]; then
        OUT="${DATA%.xml}_texttagged.xml"
        if [ -e $OUT ]; then rm -i $OUT; fi
        echo ./texttagger.pl $DATA '>' $OUT
        ./texttagger.pl $DATA > $OUT
        DATA="$OUT"
    fi

# xml formatter
    if [ "$FORMATTER_ON" = 1 ]; then
        OPTION="-a -t" # edit here
        OUT="${DATA%.xml}_${MAXNODE:-all}.xml"
        if [ -e $OUT ]; then rm -i $OUT; fi
        echo java -Xmx${MEM} -cp "../classes:../lib/xercesImpl.jar:../lib/xmlParserAPIs.jar" \
            XmlFormatter $OPTION -m${MAXNODE:-"0"} $DATA '>' $OUT
        java -Xmx${MEM} -cp "../classes:../lib/xercesImpl.jar:../lib/xmlParserAPIs.jar" \
            XmlFormatter $OPTION -m${MAXNODE:-"0"} $DATA > $OUT
        DATA="$OUT"
    fi

# xml converter
    if [ "$CONVERTER_ON" = 1 ]; then
        OUT="${DATA%.xml}.txt"
        if [ -e $OUT ]; then rm -i $OUT; fi
        echo java -Xmx${MEM} -cp "../classes" XmlConverter $DATA '|' sort -n '>' $OUT
        java -Xmx${MEM} -cp "../classes" XmlConverter $DATA | sort -n > $OUT
    fi

} # makedata()


# main
if [ "$#" = 0 ]; then
    echo "Usage: `basename $0` [-tfc] [-m MAXNODE] XMLFILE [XMLFILES...]"
    exit
else
    while [ -n "$1" ]; do
        if [ ! -e "$1" ]; then
            echo "Error: \"$1\" is not exist."
            shift
            continue
        fi

        DATA=$1
        makedata
        shift
    done
fi


# EOF
