package unot;

import java.io.*;
import java.util.*;

/**
 * ٥Ρɷϥեιɤ߹ߥ롼Υ饹.
 */
class DepthFormatLineReader extends LineReader {

	final String signature = "DepthFormatLineReader";

// 	/** 饹⤫黲Ȥȡʥ */
// 	private StreamTokenizer st; 
// 	private DocSet docset;

	public DepthFormatLineReader(DocSet docset, StreamTokenizer st) {
		super(docset, st);
	}

	String getSignature() { return signature; };
		
	/**
	 * ΡɹԤ򣱹ɤ߹ǥǡ򹹿롥
	 *
	 * @exception IOException if an error occurs
	 */
	public UnotNode readNodeLine() throws IOException
	{
		//Access UnotNode
		DocSet.NodeDict nodeDict = this.docset.getNodeDict();
		UnotNode node;

		// ʥΡֹɤ			
		if (st.ttype == StreamTokenizer.TT_NUMBER) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO,
							"@log Lookup_Node: " + (int) st.nval);

			//Access UnotNode
			//Ρֹ椫 lookupNode ǥΡɤʸ
			node = (UnotNode) nodeDict.lookupNode((int) st.nval);

		} else throw new IOException("A number token expected at self node position: "+
									 "\""+st.sval+"\"");

		// ƥΡֹɤ
		if (st.nextToken() == StreamTokenizer.TT_NUMBER) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO, " " + st.sval);

			//Access UnotNode
			UnotNode parent = nodeDict.lookupNode((int) st.nval);
			node.setParent(parent);
			if (parent != null) {
				//System.out.println("debug: parent="+parent);
				parent.getChildren().add(node);
			}

		} else throw new IOException("A number token expected at parent node position: "+"\""+st.sval+"\"");

		// ٥ʸ󤫤 lookupId ǥ٥ ID Ϳ
		if (st.nextToken() == StreamTokenizer.TT_WORD ||
			st.ttype == StreamTokenizer.TT_NUMBER ||
			st.ttype == '\"' || //ʸ
			st.ttype == '\'' || //ʸ
			true ) {
			if (DEBUG_READLINE)
				UnotLog.log(UnotLog.LOG_INFO, " " + st.sval);

			//Access UnotNode
			DocSet.LabelDict labelDict = this.docset.getLabelDict();
			node.setLabelId(labelDict.lookupId(st.sval));

		} else
			throw new IOException("A word token expected at node label position: "+"\""+st.sval+"\"");
				
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO, "\n");
		if (node == null)
			throw new IOException();

		//Access UnotNode
		return node;
	}

	/** ߤΥȡȤɤߡΥȡ˿ʤࡥ */
	int readNumberField(StreamTokenizer st) throws IOException {
		//System.out.println("debug token=["+st.nval+"]");
		if (st.ttype == StreamTokenizer.TT_NUMBER) {
			int number = (int) st.nval;
			st.nextToken(); //next char
			return number;
		} else {
			throw
				new IOException("A number token expected"+
								"["+st.sval+"]");
		}
	}

	/** ߤΥȡñȤɤߡΥȡ˿ʤࡥ */
	int readLabelField(StreamTokenizer st) throws IOException {
		//System.out.println("debug token=["+st.sval+"]");
		if (st.ttype == StreamTokenizer.TT_WORD ||
			st.ttype == '\"' || //ʸ
			st.ttype == '\'' || //ʸ
			true ) {

			//ñϿ
			DocSet.LabelDict labelDict = this.docset.getLabelDict();
			int labelId = labelDict.lookupId(st.sval); 

			st.nextToken(); //next char
			return labelId;
		} else {
			throw
				new IOException("A word token expected"+
								"["+st.sval+"]");
		}
	}

	/**
	 * ΡɹԤ򣱹ɤ߹ǥǡ򹹿롥
	 *
	 * @exception IOException if an error occurs
	 */
	public DLpair readDLpairLine() throws IOException
	{
		int nodeid, depth, labelid;
		String labelStr;
		
		// ΡIDɤ
		nodeid = readNumberField(st); 
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO,"@log "+
						"nodeid"+(int) st.nval);

		// Ρɿɤ
		depth = readNumberField(st); 
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO,"@log "+
						"depth"+depth);

		// ٥ʸɤߡ٥ IDѴ
		labelid = readLabelField(st);
		
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO, " " + labelid);

		// DLФ
		// 		System.out.println("debug"+
		// 						   " nodeid="+nodeid+
		// 						   " depth="+depth+
		// 						   " labelid="+labelid);
		DLpair nodepair = new DLpair(depth, labelid);
				
		if (DEBUG_READLINE)
			UnotLog.log(UnotLog.LOG_INFO, "\n");

		if (nodepair == null)
			throw new IOException();

		//Access UnotNode
		return nodepair;
	}


} // DepthFormatLineReader

