package unot;

public class DepthPatternWriter extends PatternWriter {
	public static final String signature = "depth";

	static final boolean DEBUG = true;
	static final String writerName = signature+" DepthPatternWriter [id depth label labelString] ";
	static final int GRAND_ROOT_ID = -1;

	DocSet docSet = null;

	public String getName() { return writerName; }

	public DepthPatternWriter(DocSet docSet) {
		if (docSet == null) {
			System.out.println("error: UnotPatternWriter:null docSet!");
			System.exit(1);
		}
		this.docSet = docSet;
	};

	String writeTree(Pattern pattern) {
		StackList nodeStack = new StackList();
		nodeStack.push(new Integer(GRAND_ROOT_ID));
		StringBuffer strBuf = new StringBuffer();

		for (int id = 0; id < pattern.getCodeSize(); id++) {
			Integer parentId = (Integer)nodeStack.getTop();
			int     depth = pattern.getNodeAt(id).getDepth();
			int     label = pattern.getNodeAt(id).getLabel();
			String  labelString = this.docSet.lookupLabelById(label);
			nodeStack.push(new Integer(id));
			putIndent(strBuf, depth);
			//strBuf.append(id+" "+depth+" "+label+" "+labelString+"\n");
			if (DEBUG)
				strBuf.append(id+" "+depth+" "+labelString+" "+label+"\n");
			else
				strBuf.append(id+" "+depth+" "+labelString+"\n");
		}

		return strBuf.toString();
	}

// 	String writeTree(StringBuffer strBuf, UnotPattern pattern) {
// 		String labelString; 
// 		return strBuf.toString();
// 	}
}


//EOF 

