package unot;

import java.io.*;
import java.util.*;

/**
 * ϥեؤΥΡɽ񤭽Ф롼Υ饹Υƥץ졼ȡ 
 */
class ParentFormatLineWriter extends LineWriter {

	public static final String signature = "parent";
	static final String writerName = signature+" "+"ParentFormatLineWriter for DocSet";
	public String getName() { return writerName; }

	public ParentFormatLineWriter(DocSet docset, PrintStream out) {
		super(docset, out);
	}

	/**
	 * Ρɤ򣱹Ԥ˽񤭽Ф
	 *
	 * @exception IOException if an error occurs
	 */
	public void writeNodeLine(UnotNode node) throws IOException
	{
		UnotNode parentNode;
		if (node == null)
			throw new IOException();

		out.print(node.getNodeId());
		out.print(" "+getNodeIdSafe(node.getParent())); 
		out.print(" "+docset.getLabelString(node));
		out.println();
	}

	int getNodeIdSafe(UnotNode parentNode) {
		if (parentNode == null)
			return -1;
		else
			return parentNode.getNodeId(); 
	}

} // ParentFormatLineWriter

//EOF 
